from hdbcli import dbapi
import sqlalchemy as db
import os
# start MySQL Docker: docker run -p 3306:3306 --name TK_ANLAGE_SAP_HANA_DATABASE -e MYSQL_ROOT_PASSWORD=my-secret-pw -d mysql:5.6
# Create Database and table!
# build this docker: docker build --tag starface-hana .
# start this docker: docker run --env-file env --net=host starface-hana

from sqlalchemy import MetaData, Table, Column, inspect
from sqlalchemy.orm import declarative_base
from hdbcli import dbapi

# settings
env = os.environ
MYSQL_ADDRESS = env.get("MYSQL_ADDRESS")
MYSQL_PORT = env.get("MYSQL_PORT")
MYSQL_TABLE = env.get("MYSQL_TABLE")
MYSQL_PASSWORD = env.get("MYSQL_PASSWORD")
MYSQL_DATABASE = env.get("MYSQL_DATABASE")
HANA_ADDRESS = env.get("HANA_ADDRESS")
HANA_PORT = env.get("HANA_PORT")
HANA_USER = env.get("HANA_USER")
HANA_PASSWORD = env.get("HANA_PASSWORD")
HANA_DATABASE = env.get("HANA_DATABASE")
HANA_TABLE = env.get("HANA_TABLE")

conn = dbapi.connect(
    address=HANA_ADDRESS,
    port=HANA_PORT,
    user=HANA_USER,
    password=HANA_PASSWORD
)
cursor = conn.cursor()

sql = 'SELECT * FROM ' + HANA_DATABASE + '."' + HANA_TABLE + '"'
cursor = conn.cursor()
cursor.execute(sql)
rows = []
for row in cursor:
    rows.append(row)

print("Data from SAP HANA: " + str(rows))

columns = [x[0] for x in cursor.description]
mysql_columns = [('ID', db.Integer, True, False), ('Company', db.String(250), False, True),
                 ('FirstName', db.String(250), False, True), ('LastName', db.String(250), False, True),
                 ('DisplayName', db.String(250), False, True), ('PhoneBusinessFormatted', db.String(250), False, True),
                 ('PhoneMobileFormatted', db.String(250), False, True)]

url = 'mysql+pymysql://{}:{}@{}:{}/{}'.format("root", MYSQL_PASSWORD, MYSQL_ADDRESS, MYSQL_PORT, MYSQL_DATABASE)
mysql_engine = db.create_engine(url)
mysql_connection = mysql_engine.connect()
mysql_base = declarative_base()
mysql_metadata = MetaData(mysql_engine)

#mysql_connection.execute("create database " + MYSQL_DATABASE)
#mysql_connection.execute("commit")

print("Dropping MYSQL table " + MYSQL_TABLE)
mysql_connection.execute("drop table " + MYSQL_TABLE)
mysql_connection.execute("commit")

mysql_table = Table(MYSQL_TABLE, mysql_metadata, *(Column(column_name, column_type,
                                                          primary_key=primary_key_flag,
                                                          nullable=nullable_flag)
                                                   for column_name, column_type, primary_key_flag, nullable_flag in
                                                   mysql_columns))
mysql_metadata.create_all(mysql_engine)
for row in rows:
    print("Insert " + str(row))
    mysql_engine.execute(mysql_table.insert(), ID=row[0], Company=row[1], FirstName=row[2], LastName=row[3],
                         DisplayName=row[4], PhoneBusinessFormatted=row[5], PhoneMobileFormatted=row[6])

mysql_connection.execute("commit")
